commit 8d4d058ef04e5c1564739f2563ab1d2cab80af05
Author: Cung Sang <csang@techfak.uni-bielefeld.de>
Date:   Wed Jul 31 17:05:22 2019 +0200

    adapt sample of DW1000 with current format on NUCLEO_F103RB

diff --git a/modules/NUCLEO-F103RB/module.h b/modules/NUCLEO-F103RB/module.h
index 4ede7fd..69c3bf5 100644
--- a/modules/NUCLEO-F103RB/module.h
+++ b/modules/NUCLEO-F103RB/module.h
@@ -36,19 +36,24 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 /*===========================================================================*/
 
-#if (BOARD_DW1000_CONNECTED == true)
-
 #if defined(__cplusplus)
 extern "C" {
 #endif /* defined(__cplusplus) */
 
+#if (BOARD_DW1000_CONNECTED == true)
 void dw1000_spi_init(void);
+void process_deca_irq(void);
+apalGpioState_t port_CheckEXT_IRQ(void) ;
+#endif /* (BOARD_DW1000_CONNECTED == true) */
+
+void set_SPI_chip_select(void);
+void clear_SPI_chip_select(void);
 
 #if defined(__cplusplus)
 }
 #endif /* defined(__cplusplus) */
 
-#endif /* (BOARD_DW1000_CONNECTED == true) */
+
 
 
 /** @} */
@@ -76,7 +81,6 @@ extern SerialConfig moduleHalProgIfConfig;
 #define MODULE_HAL_RTC                          RTCD1
 
 #if (BOARD_DW1000_CONNECTED == true)
-
 /**
  * @brief   SPI interface driver for the motion sensors (gyroscope and accelerometer).
  */
@@ -91,7 +95,6 @@ extern SPIConfig moduleHalSpiUwbHsConfig;
  * @brief   Configuration for the SPI interface driver to communicate with the wireless transceiver.
  */
 extern SPIConfig moduleHalSpiUwbLsConfig;
-
 #endif /* (BOARD_DW1000_CONNECTED == true) */
 
 /** @} */
@@ -108,8 +111,7 @@ extern SPIConfig moduleHalSpiUwbLsConfig;
  */
 extern ROMCONST apalControlGpio_t moduleGpioLed;
 
-#if (BOARD_DW1000_CONNECTED == true)
-
+//#if (BOARD_DW1000_CONNECTED == true)
 /**
  * @brief   DW1000 reset output signal
  * @note    the reset pin should be drived as low by MCU to activate.
@@ -127,8 +129,7 @@ extern ROMCONST apalControlGpio_t moduleGpioDw1000Irqn;
  * @brief   DW1000 SPI chip select  output signal.
  */
 extern ROMCONST apalControlGpio_t moduleGpioSpiChipSelect ;
-
-#endif /* (BOARD_DW1000_CONNECTED == true) */
+//#endif /* (BOARD_DW1000_CONNECTED == true) */
 
 /**
  * @brief   User button input signal.
@@ -144,14 +145,12 @@ extern ROMCONST apalControlGpio_t moduleGpioUserButton;
  */
 /*===========================================================================*/
 
-#if (BOARD_DW1000_CONNECTED == true)
-
+//#if (BOARD_DW1000_CONNECTED == true)
 /**
  * @brief   Event flag to be call dwt_isr() interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_DW1000_IRQn      AOS_IOEVENT_FLAG(PAL_PAD(LINE_ARD_D6))
-
-#endif /* (BOARD_DW1000_CONNECTED == true) */
+#define MODULE_OS_IOEVENTFLAGS_DW1000_IRQn      AOS_IOEVENT_FLAG(PAL_PAD(LINE_ARD_D14))
+//#endif /* (BOARD_DW1000_CONNECTED == true) */
 
 /**
  * @brief   Event flag to be set on a USER_BUTTON interrupt.
@@ -259,7 +258,7 @@ extern ROMCONST char* moduleShellPrompt;
    */
   #define MODULE_MAIN_LOOP_IO_EVENT_DW1000() {                                \
     if(eventflags & MODULE_OS_IOEVENTFLAGS_DW1000_IRQn) {                     \
-      /*apalGpioToggle(moduleGpioLedGreen.gpio); // just for debug  */        \
+      /*apalGpioToggle(moduleGpioLed.gpio);*/ /* just for debug*/             \
       process_deca_irq();                                                     \
     }                                                                         \
   }
@@ -298,12 +297,15 @@ extern LEDDriver moduleLldLed;
  */
 extern ButtonDriver moduleLldUserButton;
 
-#if (BOARD_DW1000_CONNECTED == true)
 
+/**
+ * @brief   DW1000 driver.
+ */
 #include <alld_DW1000.h>
+void setHighSpeed_SPI(bool speedValue, DW1000Driver* drv);
 
+#if (BOARD_DW1000_CONNECTED == true)
 extern DW1000Driver moduleLldDw1000;
-
 #endif /* (BOARD_DW1000_CONNECTED == true) */
 
 /** @} */
@@ -327,12 +329,10 @@ extern aos_shellcommand_t moduleTestLedShellCmd;
 extern aos_shellcommand_t moduleTestButtonShellCmd;
 
 #if (BOARD_DW1000_CONNECTED == true)
-
 /**
  * @brief   DW1000 (UWB transmitter) test command.
  */
 extern aos_shellcommand_t moduleTestDw1000ShellCmd;
-
 #endif /* (BOARD_DW1000_CONNECTED == true) */
 
 /**